Package org.apache.sis.metadata.iso.extent

# Class DefaultBoundingPolygon

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
AbstractGeographicExtent
DefaultBoundingPolygon

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `BoundingPolygon`, `GeographicExtent`

public class DefaultBoundingPolygon extends AbstractGeographicExtent implements BoundingPolygon
Boundary enclosing the dataset, expressed as the closed set of (x,y) coordinates of the polygon. The last point replicates first point.

The following property is mandatory in a well-formed metadata according ISO 19115:

`EX_BoundingPolygon` `└─polygon…………………` The sets of points defining the bounding polygon.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

Defined in the `sis-metadata` module

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultBoundingPolygon()`
  Constructs an initially empty bounding polygon.
  `DefaultBoundingPolygon(Geometry polygon)`
  Creates a bounding polygon initialized to the specified polygon.
  `DefaultBoundingPolygon(BoundingPolygon object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultBoundingPolygon`
  `castOrCopy(BoundingPolygon object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `Collection<Geometry>`
  `getPolygons()`
  Returns the sets of points defining the bounding polygon or other geometry.
  `void`
  `setPolygons(Collection<? extends Geometry> newValues)`
  Sets the sets of points defining the resource boundary.

  ### Methods inherited from class AbstractGeographicExtent

  `castOrCopy, getInclusion, setInclusion`

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface GeographicExtent

  `getInclusion`

- ## Constructor Details

  - ### DefaultBoundingPolygon

    public DefaultBoundingPolygon()
    Constructs an initially empty bounding polygon.

  - ### DefaultBoundingPolygon

    public DefaultBoundingPolygon(Geometry polygon)
    Creates a bounding polygon initialized to the specified polygon.
    Parameters:
      `polygon` - the sets of points defining the bounding polygon.

  - ### DefaultBoundingPolygon

    public DefaultBoundingPolygon(BoundingPolygon object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(BoundingPolygon)`

- ## Method Details

  - ### castOrCopy

    public static DefaultBoundingPolygon castOrCopy(BoundingPolygon object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultBoundingPolygon`, then it is returned unchanged.
    - Otherwise a new `DefaultBoundingPolygon` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getPolygons

    public Collection<Geometry> getPolygons()
    Returns the sets of points defining the bounding polygon or other geometry.
    Specified by:
      `getPolygons` in interface `BoundingPolygon`
    Returns:
      the sets of points defining the resource boundary.

  - ### setPolygons

    public void setPolygons(Collection<? extends Geometry> newValues)
    Sets the sets of points defining the resource boundary.
    Parameters:
      `newValues` - the new boundaries.